import partial from 'lodash.partial';
import { as } from './as';
import { not } from './not';
import { shouldReturn } from './should-return';
export var withSecretsManager = function withSecretsManager(context, manager) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Secrets manager cannot be assigned if the test was executed.");
  }

  environment.setSecretsManager(manager);
  return Object.assign(environment.promise, {
    as: partial(as, context),
    shouldReturn: partial(shouldReturn, context),
    not: partial(not, context)
  });
};
//# sourceMappingURL=with-secrets-manager.js.map