"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.makeTestEnvironment = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _core = require("@resolve-js/core");

var _runtimeBase = require("@resolve-js/runtime-base");

var _getSecretsManager = require("../../runtime/get-secrets-manager");

var _getEventStore = require("../../runtime/get-event-store");

var _getReadModelAdapter = require("../../runtime/get-read-model-adapter");

var _assertions = require("../../utils/assertions");

var makeTestEnvironment = function makeTestEnvironment(context) {
  var executed = false;
  var authToken;
  var assertion;
  var assertionNegated = false;
  var secretsManager = (0, _getSecretsManager.getSecretsManager)();
  var completeTest;
  var failTest;

  var setAuthToken = function setAuthToken(value) {
    authToken = value;
  };

  var setSecretsManager = function setSecretsManager(value) {
    secretsManager = value;
  };

  var setAssertion = function setAssertion(value) {
    assertion = value;
  };

  var getAssertion = function getAssertion() {
    return assertion;
  };

  var negateAssertion = function negateAssertion() {
    assertionNegated = true;
  };

  var isAssertionNegated = function isAssertionNegated() {
    return assertionNegated;
  };

  var isExecuted = function isExecuted() {
    return executed;
  };

  var promise = new Promise(function (resolve, reject) {
    completeTest = resolve;
    failTest = reject;
  });

  var execute = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
      var readModel, events, query, adapter, encryption, actualAdapter, actualEncryption, domain, liveErrors, makeMonitoring, errors, eventSubscriber, executor, result, actualAssertion, isNext, eventstoreAdapter, res, status, liveErrorIndex, _error, _yield$executor$read, _query$args, summaryError;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              executed = true;
              readModel = context.readModel, events = context.events, query = context.query, adapter = context.adapter, encryption = context.encryption;

              if (!(adapter != null)) {
                _context3.next = 6;
                break;
              }

              _context3.t0 = adapter;
              _context3.next = 9;
              break;

            case 6:
              _context3.next = 8;
              return (0, _getReadModelAdapter.getReadModelAdapter)();

            case 8:
              _context3.t0 = _context3.sent;

            case 9:
              actualAdapter = _context3.t0;
              actualEncryption = encryption != null ? encryption : /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        return _context.abrupt("return", null);

                      case 1:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));
              domain = (0, _core.initDomain)({
                viewModels: [],
                readModels: [{
                  name: readModel.name,
                  projection: readModel.projection,
                  resolvers: readModel.resolvers,
                  connectorName: 'ADAPTER_NAME',
                  encryption: actualEncryption
                }],
                aggregates: [],
                sagas: [],
                apiHandlers: []
              });
              liveErrors = [];

              makeMonitoring = function makeMonitoring(error, execution) {
                if (error === void 0) {
                  error = function error() {
                    return void 0;
                  };
                }

                if (execution === void 0) {
                  execution = function execution() {
                    return void 0;
                  };
                }

                return {
                  group: function group(config) {
                    var errorHandler = function errorHandler(error) {
                      if (error != null) {
                        liveErrors.push(error);
                      }
                    };

                    return config.Part === 'ReadModelProjection' ? makeMonitoring(errorHandler, errorHandler) : makeMonitoring(error, execution);
                  },
                  time: function time() {
                    return void 0;
                  },
                  timeEnd: function timeEnd() {
                    return void 0;
                  },
                  execution: execution,
                  error: error,
                  publish: function () {
                    var _publish = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
                      return _regenerator["default"].wrap(function _callee2$(_context2) {
                        while (1) {
                          switch (_context2.prev = _context2.next) {
                            case 0:
                              return _context2.abrupt("return", void 0);

                            case 1:
                            case "end":
                              return _context2.stop();
                          }
                        }
                      }, _callee2);
                    }));

                    function publish() {
                      return _publish.apply(this, arguments);
                    }

                    return publish;
                  }(),
                  duration: function duration() {
                    return void 0;
                  },
                  custom: function custom() {
                    return void 0;
                  },
                  getMetrics: function getMetrics() {
                    return {
                      metrics: []
                    };
                  },
                  clearMetrics: function clearMetrics() {
                    return void 0;
                  },
                  rate: function rate() {
                    return void 0;
                  }
                };
              };

              errors = [];
              eventSubscriber = null;
              executor = null;
              result = null;
              actualAssertion = assertion != null ? assertion : _assertions.defaultAssertion;
              isNext = false;
              _context3.prev = 20;
              _context3.next = 23;
              return (0, _getEventStore.getEventStore)(events);

            case 23:
              eventstoreAdapter = _context3.sent;
              eventSubscriber = (0, _runtimeBase.eventSubscriberFactory)({
                getEventSubscriberDestination: function getEventSubscriberDestination() {
                  return 'LOCAL';
                },
                applicationName: 'APP_NAME',
                readModelConnectors: {
                  ADAPTER_NAME: actualAdapter
                },
                getVacantTimeInMillis: function getVacantTimeInMillis() {
                  return 0x7fffffff;
                },
                eventstoreAdapter: eventstoreAdapter,
                readModelsInterop: domain.readModelDomain.acquireReadModelsInterop({
                  secretsManager: secretsManager,
                  monitoring: makeMonitoring()
                }),
                performanceTracer: null,
                loadReadModelProcedure: function loadReadModelProcedure() {
                  return Promise.resolve(null);
                },
                setCurrentEventSubscriber: function setCurrentEventSubscriber() {
                  return void 0;
                },
                sagasInterop: {},
                monitoring: null
              });
              executor = (0, _runtimeBase.createQueryExecutor)({
                readModelConnectors: {
                  ADAPTER_NAME: actualAdapter
                },
                readModelsInterop: domain.readModelDomain.acquireReadModelsInterop({
                  secretsManager: secretsManager,
                  monitoring: makeMonitoring()
                }),
                viewModelsInterop: {},
                performanceTracer: null,
                monitoring: null,
                eventSubscriber: eventSubscriber
              });
              _context3.prev = 26;
              _context3.next = 29;
              return executor.subscribe({
                modelName: readModel.name,
                subscriptionOptions: {
                  eventTypes: null,
                  aggregateIds: null
                }
              });

            case 29:
              _context3.next = 31;
              return executor.resume({
                modelName: readModel.name
              });

            case 31:
              isNext = false; // TODO ???

              _context3.next = 34;
              return executor.build({
                modelName: readModel.name
              });

            case 34:
              res = _context3.sent;

              if (res.payload["continue"]) {
                isNext = true;
              }

            case 36:
              if (isNext) {
                _context3.next = 31;
                break;
              }

            case 37:
              _context3.next = 39;
              return executor.status({
                modelName: readModel.name
              });

            case 39:
              status = _context3.sent;

              if (!(status.status === 'error')) {
                _context3.next = 51;
                break;
              }

              if (Array.isArray(status.errors)) {
                _context3.next = 43;
                break;
              }

              throw new Error('Unknown error');

            case 43:
              liveErrorIndex = status.errors.length === 1 ? liveErrors.findIndex(function (err) {
                return err.message === status.errors[0].message;
              }) : -1;

              if (!(liveErrorIndex < 0)) {
                _context3.next = 50;
                break;
              }

              _error = new Error(status.errors.map(function (err) {
                return err.message;
              }).join('\n'));
              _error.stack = status.errors.map(function (err) {
                return err.stack;
              }).join('\n');
              throw _error;

            case 50:
              throw liveErrors[liveErrorIndex];

            case 51:
              _context3.next = 56;
              break;

            case 53:
              _context3.prev = 53;
              _context3.t1 = _context3["catch"](26);
              errors.push(_context3.t1);

            case 56:
              _context3.prev = 56;
              _context3.next = 59;
              return executor.read({
                modelName: readModel.name,
                resolverName: query.resolver,
                resolverArgs: (_query$args = query.args) !== null && _query$args !== void 0 ? _query$args : {},
                jwt: authToken
              });

            case 59:
              _yield$executor$read = _context3.sent;
              result = _yield$executor$read.data;
              void _yield$executor$read;
              _context3.next = 67;
              break;

            case 64:
              _context3.prev = 64;
              _context3.t2 = _context3["catch"](56);
              errors.push(_context3.t2);

            case 67:
              _context3.prev = 67;
              _context3.next = 70;
              return executor.unsubscribe({
                modelName: readModel.name
              });

            case 70:
              _context3.next = 75;
              break;

            case 72:
              _context3.prev = 72;
              _context3.t3 = _context3["catch"](67);
              errors.push(_context3.t3);

            case 75:
              _context3.next = 80;
              break;

            case 77:
              _context3.prev = 77;
              _context3.t4 = _context3["catch"](20);
              errors.push(_context3.t4);

            case 80:
              if (!(errors.length === 0)) {
                _context3.next = 84;
                break;
              }

              return _context3.abrupt("return", actualAssertion(completeTest, failTest, result, null, assertionNegated));

            case 84:
              summaryError = errors[0];

              if (errors.length > 1) {
                summaryError = new Error(errors.map(function (err) {
                  return err.message;
                }).join('\n'));
                summaryError.stack = errors.map(function (err) {
                  return err.stack;
                }).join('\n');
              } // eslint-disable-next-line no-console


              console.error(summaryError);
              return _context3.abrupt("return", actualAssertion(completeTest, failTest, null, errors[0], assertionNegated));

            case 88:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[20, 77], [26, 53], [56, 64], [67, 72]]);
    }));

    return function execute() {
      return _ref.apply(this, arguments);
    };
  }();

  setImmediate(execute);
  return {
    setAuthToken: setAuthToken,
    setSecretsManager: setSecretsManager,
    setAssertion: setAssertion,
    getAssertion: getAssertion,
    negateAssertion: negateAssertion,
    isAssertionNegated: isAssertionNegated,
    isExecuted: isExecuted,
    promise: promise
  };
};

exports.makeTestEnvironment = makeTestEnvironment;
//# sourceMappingURL=make-test-environment.js.map