import type { EventHandlerEncryptionFactory, SecretsManager } from '@resolve-js/core';
import type { TestReadModel, QueryTestResult, TestEvent, TestQuery, TestQueryAssertion } from '../../types';
declare type ReadModelTestContext = {
    readModel: TestReadModel;
    events: TestEvent[];
    query: TestQuery;
    adapter?: any;
    encryption?: EventHandlerEncryptionFactory;
};
export declare type ReadModelTestEnvironment = {
    promise: Promise<QueryTestResult>;
    setAuthToken: (token: string) => void;
    setSecretsManager: (manager: SecretsManager) => void;
    setAssertion: (assertion: TestQueryAssertion) => void;
    getAssertion: () => TestQueryAssertion;
    negateAssertion: () => void;
    isAssertionNegated: () => boolean;
    isExecuted: () => boolean;
};
export declare const makeTestEnvironment: (context: ReadModelTestContext) => ReadModelTestEnvironment;
export {};
